﻿//---------------------------------------------------------------------------
// 串口控件演示程序，Copyright © Victor Chen

#ifndef UnitTsDataH
#define UnitTsDataH
//---------------------------------------------------------------------------
#include <vcl.h>
#include <io.h>
#include <dir.h>
#include <stdio.h>
//---------------------------------------------------------------------------
const DataSize=4096;
#pragma pack(push,1)
enum TMyPkgCmd
{
  mpcUpload   = 1,
  mpcFileData = 2,
  mpcStatus   = 3,
};

typedef struct
{
  unsigned char cmd;     //1 (1: upload, 2: filedata, 3:status)
  unsigned char id;
  double        time;    //date & time
  long size;             //filesize
  wchar_t name[MAXPATH]; //filename
  unsigned long CRC;
} TMyFinfoPkg;

typedef struct
{
  unsigned char cmd; //2 (1: upload, 2: filedata, 3:status)
  unsigned char id;
  long from;
  long size;
  char data[DataSize];
  unsigned long CRC;
} TMyFdataPkg;

typedef struct
{
  unsigned char cmd;     //3
  unsigned char id;
  unsigned char anscmd;
  unsigned char status;  //0x88: OK
  unsigned long CRC;
} TMyStatusPkg;

#pragma pack(pop)
//---------------------------------------------------------------------------

extern unsigned long CRC32(unsigned long c, void *s, int n);
extern int MakePercent(unsigned long lPos, unsigned long lCount);
//---------------------------------------------------------------------------
#endif
