﻿/***************************************************************************\
*                                                                           *
*         Unit_YBComm32_About.cpp - 串行口通讯关于窗口, 版本 1.5.0.1        *
*                              Bulid: 01-26-2010                            *
*                     Copyright © 1997-2010, Victor Chen                    *
*                      Homepage: http://www.cppfans.com                     *
*                          Email: victor@cppfans.com                        *
*                                                                           *
\***************************************************************************/

#include <vcl.h>
#pragma hdrstop

#include <tchar.h>
#include "TVictorComm32.h"
#include "Unit_YBComm32_About.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
namespace VictorComm32 {
//---------------------------------------------------------------------------
// TForm_YBComm32_About *Form_YBComm32_About;
//---------------------------------------------------------------------------
__fastcall TForm_YBComm32_About::TForm_YBComm32_About(TComponent* Owner, UnicodeString PName)
    : TForm(Owner)
{
  TComm32Language _Comm32Language;

  LabelCaption->ParentFont = true;
  LabelCaption->Font->Size = 11;

  LabelHomepage->Font->Color = clBlue;
  LabelHomepage->Font->Style = TFontStyles()<<fsUnderline;

  LabelEmail->Font->Color = clBlue;
  LabelEmail->Font->Style = TFontStyles()<<fsUnderline;

  TMsgStrings Msgs;
  Caption = Msgs.Str_About + PName + Msgs.Str_DotDotDot;
  LabelCaption ->Caption = PName;
  LabelVersion ->Caption = Msgs.Str_CRgtVersion ; //"版本: 1.00"
  LabelCo      ->Caption = Msgs.Str_CRgtCoName  ; //"Copyright (c) Victor Chen"
  LabelHomepage->Caption = Msgs.Str_CRgtHomePage; //"http://www.cppfans.com"
  LabelHomepage->Hint    = Msgs.Str_CRgtHomePage; //"http://www.cppfans.com"
  LabelEmail   ->Caption = Msgs.Str_CRgtAuEmail ; //"victor@cppfans.com"
  LabelEmail   ->Hint    = Msgs.Str_CRgtAuMailTo; //"mailto:victor@cppfans.com"
  LabelPmtUser ->Caption = Msgs.Str_User        ; //"用户"
  LabelPmtOrgn ->Caption = Msgs.Str_Orgn        ; //"单位"
  BnOK         ->Caption = Msgs.Str_OK          ; //"确定"

  ShowSysInfo();
}  
//---------------------------------------------------------------------------
void __fastcall TForm_YBComm32_About::ShowSysInfo(void)
{
  bool bIsNT = false;
  DWORD dwMajorVer = 0;  //4    //4.10.1998
  DWORD dwMinorVer = 0;  //10   //4.10.1998
  DWORD dwBuildNum = 0;  //1998 //4.10.1998
  UnicodeString sOSName, sOtherInfo;
  UnicodeString sRegUser, sRegOrg;

  OSVERSIONINFO ovi;
  ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
  if(GetVersionEx(&ovi))
   {
     bIsNT = ovi.dwPlatformId == VER_PLATFORM_WIN32_NT;
     dwMajorVer = ovi.dwMajorVersion;
     dwMinorVer = ovi.dwMinorVersion;
     dwBuildNum = LOWORD(ovi.dwBuildNumber);

     sOSName = "Windows";
     if(bIsNT)
      {
        sOtherInfo=ovi.szCSDVersion; //"Service Pack 1"
        if((ovi.dwMajorVersion==5) && (ovi.dwMinorVersion==0)) //5.00.2195
          sOSName += " 2000";
        else if((ovi.dwMajorVersion==5) && (ovi.dwMinorVersion==1)) //5.01.xxxx
          sOSName += " XP";
        else if((ovi.dwMajorVersion==5) && (ovi.dwMinorVersion==2)) //5.01.xxxx
          sOSName += " 2003";
        else if((ovi.dwMajorVersion==6) && (ovi.dwMinorVersion==0)) //6.00.xxxx
          sOSName += " Vista";
        else //Other Windows NT Kernel OS
          sOSName += " NT";
      }
     else //不是WinNT
      {
        if(ovi.dwMajorVersion==4) //Win9x/WinME
         {
           if(ovi.dwMinorVersion==0) //Win95 = 4.00.950
            {
              sOSName += " 95";
              if(LOWORD(ovi.dwBuildNumber)>=1111) //Win95 OSR2 = 4.00.1111
                sOSName += " OSR2";
            }
           else if(ovi.dwMinorVersion==10) //Win98 = 4.10.1998
            {
              sOSName += " 98";
              if(LOWORD(ovi.dwBuildNumber)>=2222) //Win98 SE = 4.10.2222
                sOSName += " SE";
            }
           else if(ovi.dwMinorVersion==90) //WinME = 4.90.3333
            {
              sOSName += " ME";
            }
         }
      }
   }

  HKEY hKey;
  bool bRegOK = bIsNT ? RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\Microsoft\\Windows NT\\CurrentVersion"), 0, KEY_READ, &hKey)==ERROR_SUCCESS:
                        RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("Software\\Microsoft\\Windows\\CurrentVersion"), 0, KEY_READ, &hKey)==ERROR_SUCCESS;
  if(bRegOK)
   {
     try
      {
        TCHAR sValue[256];
        DWORD dwValueSize=sizeof(sValue);
        if(RegQueryValueEx(hKey, _T("RegisteredOwner"), NULL, NULL, (BYTE*)sValue, &dwValueSize)==ERROR_SUCCESS)
          sRegUser = sValue;
        dwValueSize=sizeof(sValue);
        if(RegQueryValueEx(hKey, _T("RegisteredOrganization"), NULL, NULL, (BYTE*)sValue, &dwValueSize)==ERROR_SUCCESS)
          sRegOrg = sValue;
      }
     __finally
      {
        RegCloseKey(hKey);
      }
   }

  LabelOSVer->Caption = UnicodeString().sprintf(_T("%s %d.%02d.%04d %s"), sOSName.w_str(), dwMajorVer, dwMinorVer, dwBuildNum, sOtherInfo.w_str());
  LabelUser->Caption = sRegUser;
  LabelUserOrg->Caption = sRegOrg;
}
//---------------------------------------------------------------------------
void __fastcall TForm_YBComm32_About::LabelHomepageClick(TObject *Sender)
{
  ShellExecute(Application->Handle, _T("open"), TMsgStrings().Str_CRgtHomePage.w_str(), NULL, _T(""), SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------
void __fastcall TForm_YBComm32_About::LabelEmailClick(TObject *Sender)
{
  ShellExecute(Application->Handle, _T("open"), TMsgStrings().Str_CRgtAuMailTo.w_str(), NULL, _T(""), SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------
void __fastcall TForm_YBComm32_About::BnOKClick(TObject *Sender)
{
  ModalResult = IDOK;
}
//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------
__fastcall TForm_YBComm32_About::TMsgStrings::TMsgStrings()
{
  static const wchar_t *_Msg_Chs[] =
   {
     L"关于 "                    , // 0 Str_About
     L"……"                       , // 1 Str_DotDotDot
     L"用户:"                    , // 2 Str_User
     L"单位:"                    , // 3 Str_Orgn
     L"版本: 1.5.0.1"            , // 4 Str_CRgtVersion
     L"Copyright © Victor Chen"  , // 5 Str_CRgtCoName
     L"http://www.cppfans.com"   , // 6 Str_CRgtHomePage
     L"victor@cppfans.com"       , // 7 Str_CRgtAuEmail
     L"mailto:victor@cppfans.com", // 8 Str_CRgtAuMailTo
     L"确定"                     , // 9 Str_OK
     L"设置(&S)..."              , //10 Str_Settings
     L"关于(&A)..."              , //11 Str_MenuAbout
   };
  static const wchar_t *_Msg_Cht[] =
   {
     L"關於 "                    , // 0 Str_About
     L"……"                       , // 1 Str_DotDotDot
     L"用戶:"                    , // 2 Str_User
     L"單位:"                    , // 3 Str_Orgn
     L"版本: 1.5.0.1"            , // 4 Str_CRgtVersion
     L"Copyright © Victor Chen"  , // 5 Str_CRgtCoName
     L"http://www.cppfans.com"   , // 6 Str_CRgtHomePage
     L"victor@cppfans.com"       , // 7 Str_CRgtAuEmail
     L"mailto:victor@cppfans.com", // 8 Str_CRgtAuMailTo
     L"確定"                     , // 9 Str_OK
     L"設置(&S)..."              , //10 Str_Settings
     L"關於(&A)..."              , //11 Str_MenuAbout
   };
  static const wchar_t *_Msg_Enu[] =
   {
     L"About "                   , //0 Str_About
     L"..."                      , //1 Str_DotDotDot
     L"User:"                    , //2 Str_User
     L"Orgn:"                    , //3 Str_Orgn
     L"Version: 1.5.0.1"         , //4 Str_CRgtVersion
     L"Copyright © Victor Chen"  , //5 Str_CRgtCoName
     L"http://www.cppfans.com"   , //6 Str_CRgtHomePage
     L"victor@cppfans.com"       , //7 Str_CRgtAuEmail
     L"mailto:victor@cppfans.com", //8 Str_CRgtAuMailTo
     L"OK"                       , //9 Str_OK
     L"&Settings..."             , //10 Str_Settings
     L"&About..."                , //11 Str_MenuAbout
   };

  switch(_Comm32Language.lcId)
   {
     case TComm32Language::lcidChs:
          _Msg = _Msg_Chs;
          break;

     case TComm32Language::lcidCht:
          _Msg = _Msg_Cht;
          break;

     default:
          _Msg = _Msg_Enu;
          break;
   }
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TForm_YBComm32_About::TMsgStrings::fGetMsg(int mt)
{
  return _Msg[mt];
}
//---------------------------------------------------------------------------
} // namespace VictorComm32
//---------------------------------------------------------------------------
